package com.dsic.gj_erp.controller;

import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.request.LoginBean;
import com.dsic.gj_erp.mapper.SyuserMapper;
import com.dsic.gj_erp.service.ApiService;
import com.dsic.gj_erp.service.sy.SYService;
import com.dsic.gj_erp.util.MD5Util;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

@Api(tags = "系统级API")
@RestController
@Validated
@RequestMapping(value = "/api",method= RequestMethod.POST)
public class ApiController {

    @Autowired
    ApiService apiService;
    @Autowired
    private SyuserMapper syuserMapper;
    @Autowired
    SYService syService;
    @RequestMapping(value = "/login")
    public ResultBean login(@RequestBody @Validated LoginBean loginBean,HttpServletRequest request) throws Exception {

//        List<String> list=new ArrayList<>();
//        for (int i = 0; i < 10; i++) {
//            String a= syService.f_getpjh("DM","DM","CZPL");
//            System.out.println(a);
//            list.add(a);
//        }
//        System.out.println(list);
//        //
//        String hostAddress = InetAddress.getLocalHost().getHostAddress();
//        System.out.print("hostAddress ");
//        System.out.println(hostAddress);
        return new ResultBean(apiService.userLogin(loginBean, request));
    }

    @Value("${zxtbm}")
    public String zxtbm;

    @AuthFunction
    @RequestMapping(value = "/getInfo")
    public ResultBean getInfo(HttpServletRequest request) {
        String yhdm = (String) request.getAttribute("yhdm");
        String zxtdm = (String) request.getAttribute("zxtdm");



        Map<String, Object> map= apiService.getInfo(yhdm);
        map.put("menu", syuserMapper.getUserMenu(yhdm, zxtbm));
        return new ResultBean(map);
    }

    @AuthFunction
    @RequestMapping(value = "/updatePassword")
    public ResultBean updatePassword(@RequestBody Map<String, Object> paramMap,HttpServletRequest request) {
        String yhdm = (String) request.getAttribute("yhdm");
        String newPWD= (String) paramMap.get("confirmpwd");
        apiService.updatePassword(yhdm, MD5Util.encrypt(newPWD));
        return new ResultBean();
    }



}
