package com.dsic.gj_erp.jszb.entity;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.annotation.ExcelProperty;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.dsic.gj_erp.jszb.excel.ExcelFlowInfoListener;
import lombok.Getter;
import lombok.Setter;

import java.io.File;
import java.util.List;

@Getter
@Setter
@TableName("part_flow_info")
public class PartFlowInfo {
    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String  id;
    @ExcelProperty("船号")
    private String ch;
    @ExcelProperty("分段号")
    private String fd;
    @ExcelProperty("批量")
    private String pl;
    @ExcelProperty("零件名称")
    private String partName;
    @ExcelProperty("种类")
    private String type;
    @ExcelProperty("规格")
    private String specification;
    @ExcelProperty("数量")
    private String quantity;
    @ExcelProperty("材质")
    private String material;
    @ExcelProperty("特征")
    private String feature;
    @ExcelProperty("流向")
    private String flow;
    @ExcelProperty("下级")
    private String nextLevel;
    @ExcelProperty("套料图信息")
    private String nestingInfo;
    @ExcelProperty("场地")
    private String location;

    //========重量信息========
    @TableField(exist = false)
    @ExcelProperty("PROJECT")
    private String project;
    @TableField(exist = false)
    @ExcelProperty("BLOCK")
    private String block;
    @TableField(exist = false)
    @ExcelProperty("PARTNAME")
    private String partName0;
    @ExcelProperty("PARTNO")
    private String partNo;
    @ExcelProperty("MATERIAL")
    private String material0;
    @ExcelProperty("THICK")
    private String thickness;
    @ExcelProperty("TYPE")
    private String type0;
    @ExcelProperty("P")
    private String p;
    @ExcelProperty("C")
    private String c;
    @ExcelProperty("S")
    private String s;
    @ExcelProperty("NP")
    private String np;
    @ExcelProperty("NC")
    private String nc;
    @ExcelProperty("NS")
    private String ns;
    @ExcelProperty("AREA")
    private String area;
    @ExcelProperty("WEIGHT")
    private String weight;
    @ExcelProperty("CUTLEN")
    private String cutLength;
    @ExcelProperty("MARKLEN")
    private String markLength;

    @ExcelProperty("X-SIZE")
    @TableField("x_size")
    private String xxSize;//x-size
    @ExcelProperty("Y-SIZE")
    @TableField("y_size")
    private String yySize;//y-size

    @ExcelProperty("OPTION")
    private String option0;
    @ExcelProperty("MPARTNAME")
    private String m_part_name;
    @ExcelProperty("SPARTNAME")
    private String s_part_name;
    @ExcelProperty("LOT")
    private String lot;
    @ExcelProperty("BAREA")
    @TableField("b_area")
    private String bbArea;
    @ExcelProperty("SANGLE")
    @TableField("s_angle")
    private String ssAngle;
    @ExcelProperty("SSIZE-X")
    @TableField("s_size_x")
    private String ssSizeX;
    @ExcelProperty("SSIZE-Y")
    @TableField("s_size_y")
    private String ssSizeY;
    @ExcelProperty("GOID")
    private String goid;
    @ExcelProperty("DATE")
    private String date;
    @ExcelProperty("TIME")
    private String time;
    @ExcelProperty("SHAPE")
    private String shape;
    @ExcelProperty("ASSEMBLY")
    private String assembly;
    @ExcelProperty("OPTION1")
    private String option1;
    @ExcelProperty("OPTION2")
    private String option2;
    @ExcelProperty("OPTION3")
    private String option3;
    @ExcelProperty("OPTION4")
    private String option4;
    @ExcelProperty("OPTION5")
    private String option5;
    @ExcelProperty("DIRECTION")
    private String direction;
    @ExcelProperty("ISMODIFY")
    private String isModify;
    @ExcelProperty("NESTNAME")
    private String nestName;

    public static void main(String[] args) {
        ExcelFlowInfoListener objectListener = new ExcelFlowInfoListener();
        EasyExcel.read(new File("E:\\文档\\润芃\\项目管理\\钢加\\生产管控\\实施相关\\2025年4月\\技术准备\\零件重量信息.xls"), PartFlowInfo.class, objectListener).sheet(0).headRowNumber(1).doRead();

        List<PartFlowInfo> objList = objectListener.getObjectList();
        System.out.println(objList);
    }
}
