package com.dsic.gj_erp.service.pgd.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.DmBchxjbp;
import com.dsic.gj_erp.bean.jcsj.DmBclqjbp;
import com.dsic.gj_erp.bean.pgd.PgdTzjh;
import com.dsic.gj_erp.mapper.pgd.PgdTzjhMapper;
import com.dsic.gj_erp.service.jcsj.DmBchxjbpService;
import com.dsic.gj_erp.service.jcsj.DmBclqjbpService;
import com.dsic.gj_erp.service.pgd.PgdTzjhService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@Service
@AllArgsConstructor
public class PgdTzjhServiceImpl extends ServiceImpl<PgdTzjhMapper, PgdTzjh> implements PgdTzjhService {

    private final DmBclqjbpService dmBclqjbpService;
    private final DmBchxjbpService dmBchxjbpService;


    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveTzjhPgdXd(List<PgdTzjh> tzjhs, HttpServletRequest request) {
        List<PgdTzjh>ups= new ArrayList<>();
        tzjhs.forEach(f->{
            PgdTzjh e= new PgdTzjh();
            e.setXfry((String) request.getAttribute("yhms"));
            e.setXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("02");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveTzjhPgdFk(List<PgdTzjh> tzjhs, HttpServletRequest request) {
        List<PgdTzjh>ups= new ArrayList<>();
        tzjhs.forEach(f->{
            PgdTzjh e= new PgdTzjh();
            e.setFkry((String) request.getAttribute("yhms"));
            e.setFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("09");
            e.setFkyy(f.getFkyy());
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveTzjhPgdXdBack(List<PgdTzjh> tzjhs, HttpServletRequest request) {
        List<PgdTzjh>ups= new ArrayList<>();
        tzjhs.forEach(f->{
            PgdTzjh e= new PgdTzjh();
            e.setXfry((String) request.getAttribute("yhms"));
            e.setXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            if(f.getZt().equals("02")){
                e.setZt("01");
            }
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    /**
     * 根据板材领取表和板材套料图,检查并更新图纸计划派工单完成情况
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public void updateForCheck(List<PgdTzjh> list,String username) {
        Map<String, List<PgdTzjh>> map = list.stream()
                .collect(Collectors.groupingBy(item -> item.getCzbh() + "_" + item.getPl()));

        List<PgdTzjh> updateList=new ArrayList<>();
        map.forEach((key,val)->{
            List<PgdTzjh> tmpList=new ArrayList<>();
            String czbh=key.split("_")[0];
            String pl=key.split("_")[1];

            List<DmBclqjbp> list1 = dmBclqjbpService.list(Wrappers.<DmBclqjbp>lambdaQuery()
                    .eq(DmBclqjbp::getDcCh, czbh)
                    .eq(DmBclqjbp::getDcPl, pl)
            );
            if (ObjUtil.isNotEmpty(list1)){
                for(DmBclqjbp dmBclqjbp : list1){
                    for (PgdTzjh pgdTzjh : val){
                        if (dmBclqjbp.getDcFd().contains(pgdTzjh.getFd())){
                            PgdTzjh updateData = new PgdTzjh();
                            updateData.setId(pgdTzjh.getId());
                            updateData.setZt("09");
                            updateData.setFkrq(dmBclqjbp.getDerq());
                            updateData.setFkry(username);
                            tmpList.add(updateData);
                        }
                    }
                }
            }
            if (ObjUtil.isEmpty(tmpList)){
                return;
            }
            List<DmBchxjbp> list2 = dmBchxjbpService.list(Wrappers.<DmBchxjbp>lambdaQuery()
                    .eq(DmBchxjbp::getDcCh, czbh)
                    .eq(DmBchxjbp::getDcPl, pl)
            );
            if (ObjUtil.isNotEmpty(list2)){
                updateList.addAll(tmpList);
            }
        });
        boolean b = ObjUtil.isNotEmpty(updateList) && this.updateBatchById(updateList, 500);
    }
}
